﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Deffered
{
    public static class Extensions
    {
        //public static IEnumerable<Oddzial> Where(this IEnumerable<Oddzial> oddzialy, Func<Oddzial, bool> predicate)
        //{
        //    List<Oddzial> result = new List<Oddzial>();

        //    foreach (var o in oddzialy)
        //        if (predicate(o))
        //            result.Add(o);

        //    return result;
        //}

        public static IEnumerable<Oddzial> Where(this IEnumerable<Oddzial> oddzialy, Func<Oddzial, bool> predicate)
        {
            foreach (var o in oddzialy)
                if (predicate(o))
                    yield return o;
        }
    }


    public class Oddzial
    {
        private int _id;
        public int Id { get { return _id; } set { _id = value; } }
        public string Nazwa { get; set; }

        public static List<Oddzial> GetAll()
        {
            return new List<Oddzial>(new[] {
                new Oddzial { Id = 1, Nazwa = "Marketing" },
                new Oddzial { Id = 2, Nazwa = "Handlowy" },
                new Oddzial { Id = 3, Nazwa = "IT" }
            });
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            List<Oddzial> oddzialy = Oddzial.GetAll();

            var q1 = oddzialy.Where(e => e.Nazwa.Length < 9 & e.Id < 3).ToList();
            var q2 = oddzialy.Where(e => e.Nazwa.Length < 9 & e.Id < 3);

            PrintAll(q1);
            oddzialy.Add(new Oddzial { Id = 0, Nazwa = "TEST" });
            PrintAll(q1);
            PrintAll(q2);

            Console.ReadLine();
        }

        static void PrintAll(IEnumerable<Oddzial> q)
        {
            foreach (var i in q)
                Console.WriteLine(i.Nazwa);
            Console.WriteLine();
        }
    }
}


